<?php
/**
 * Plugin Name: Wehiko.de
 * Plugin URI: https://wordpress-mobile.de
 * Description: Wordpress + Mobile.de integration plugin
 * Version: 1.1.0
 * Author: wehiko.de | Fewolino x Vanillia
 * Author URI: https://wordpress-mobile.de
 */
$apiKey = "AIzaSyCXS_1BR2H9-1KMUG3_iyKwx1cNVi-U-F8";
$_ENV["apiKey"] = $apiKey;

function mobile_de_plugin_register_settings() {
    add_options_page( 'Wehiko.de plugin', 'Wehiko.de plugin', 'manage_options', 'dbi-mobile-de-plugin', 'dbi_render_plugin_settings_page');
}

function dbi_render_plugin_settings_page() {    
    ?>
    <script src="https://www.gstatic.com/firebasejs/7.23.0/firebase-app.js"></script>
    <script src="https://www.gstatic.com/firebasejs/7.23.0/firebase-auth.js"></script>
    <script defer src="https://www.gstatic.com/firebasejs/ui/4.6.1/firebase-ui-auth.js"></script>
    <link defer type="text/css" rel="stylesheet" href="https://www.gstatic.com/firebasejs/ui/4.6.1/firebase-ui-auth.css" />
    <style>
        .form-table th {
            vertical-align: middle;
            text-align: left;
            padding: 10px 10px 0px 0;
            width: 220px;
            line-height: 1;
            font-weight: 600;
        }

        .form-table td {
            margin-bottom: 9px;
            padding: 10px 10px 0 10px;
            line-height: 1;
            vertical-align: middle;
        }
        .main{
            display:none;
            grid-template-columns: minmax(auto, 450px) minmax(400px, 600px);
            grid-template-rows: 1fr auto;        
        }

        .youtube-video {
            width: 100%;
            height: 232px;
        }
                
        @media only screen and (min-width: 1200px) {
            .main {
                justify-content: center;                
            }
            .youtube-video {
                width: 560px;
                height: 325px;
            }
        }     
    </style>
    <script defer>
    window.onload = function() {
        var firebaseConfig = {
            apiKey: "<?php echo $_ENV["apiKey"] ?>",
            authDomain: "mobile-de-plugin.firebaseapp.com",
            databaseURL: "https://mobile-de-plugin.firebaseio.com",
            projectId: "mobile-de-plugin",
            storageBucket: "mobile-de-plugin.appspot.com",
            messagingSenderId: "673933862042",
            appId: "1:673933862042:web:45ae85434db894e4bf2b23",
            measurementId: "G-PTTDMXRKJ3"
        };
  
        // Initialize Firebase
        firebase.initializeApp(firebaseConfig);
            // Initialize the FirebaseUI Widget using Firebase.
            var ui = new firebaseui.auth.AuthUI(firebase.auth());
            var uiConfig = {
            callbacks: {
                signInSuccessWithAuthResult: function(authResult, redirectUrl) {
                // User successfully signed in.
                // Return type determines whether we continue the redirect automatically
                // or whether we leave that to developer to handle.
                
                return false;
                },
                uiShown: function() {
                // The widget is rendered.
                // Hide the loader.
                document.getElementById('loader').style.display = 'none';
                }
            },
            // Will use popup for IDP Providers sign-in flow instead of the default, redirect.
            signInFlow: 'popup',
            signInSuccessUrl: document.location.href + '#signed-in',
            signInOptions: [
                // Leave the lines as is for the providers you want to offer your users.
                firebase.auth.GoogleAuthProvider.PROVIDER_ID,
                //firebase.auth.FacebookAuthProvider.PROVIDER_ID,        
                firebase.auth.EmailAuthProvider.PROVIDER_ID                
            ],
            // Terms of service url.
            tosUrl: '<your-tos-url>',
            // Privacy policy url.
            privacyPolicyUrl: '<your-privacy-policy-url>'
            };
            
        firebase.auth().onAuthStateChanged(function(user) {
        if (user) {
            // User is signed in.
            var displayName = user.displayName;
            var email = user.email;
            var emailVerified = user.emailVerified;
            var photoURL = user.photoURL;
            var isAnonymous = user.isAnonymous;
            var uid = user.uid;                
            var userId = firebase.auth().currentUser.uid;
            firebase.auth().currentUser.getIdToken(/* forceRefresh */ true).then(function(idToken) {
                document.getElementById('username').innerHTML = email;
                document.getElementById('loader').style.display = 'none';
                
                document.getElementById('plugin-settings').style.display = 'grid';
                document.getElementById('login-info').style.display = 'none';
                document.getElementById('dbi_plugin_setting_refresh_token').value = user.refreshToken;                
            }).catch(function(error) {
            // Handle error
            });
                        
            ui.reset();
        } else {
            // User is signed out.
            document.getElementById('plugin-settings').style.display = 'none';
            document.getElementById('login-info').style.display = 'flex';
            console.log('user is signed out');                
            ui.start('#firebaseui-auth-container', uiConfig);                
        }
        });

        document.getElementById('signOut').addEventListener('click', function(event) {
            if (firebase.auth().currentUser){
                firebase.auth().signOut();
            }
        });
    }
    </script>
    <h1 style="text-align:center; margin-bottom: 50px;">Wehiko.de Plugin Einstellungen</h1>
    <div style="display:none; justify-content:center;" id="login-info">
        <div style="padding-top: 10px;max-width:500px;min-width: 500px;" id="firebaseui-auth-container"></div>
        <div style="width: 600px;max-width: 600px; padding-left: 30px; padding-right:30px;" >
            <h3>Diese E-Mail Adresse wird lediglich für das Erstellen des Wehiko Kontos benötig. </h3>
            <p>Wenn du also Web Designer bist, nutze bitte deine eigene E-Mail Adresse. </p>
            <!-- Wenn du Autohaus Inhaber bist, nutze deine eigene E-Mail Adresse.  -->
            Wir nutzen diese E-Mail Adresse lediglich für den Customer Support.
            Sobald du einen Account mit uns erstellt hast, kanns du im zweiten Schritt die 3 benötigten Credentials angeben, die benötigt werden, um die Synchronization zwischen mobile.de und der Wordpress Website zu aktivieren (siehe Blogartikel <a href="https://wordpress-mobile.de/inseratseinbindung-im-mobilede-haendler-account-aktivieren/">mobile.de Inserats-Einbindung für WordPress aktivieren</a>)
        </div>
    </div>
    <div id="loader" style="display: flex; justify-content:center;font-size: large; ">Ein moment bitte ...</div>
    <div id="plugin-settings" class="main">
            <div style="grid-column: 2; grid-row: 1; text-align: right; padding-right: 10px;">
                <span id="username"></span>
                <button id="signOut">Abmelden</button>
            </div>
            <div style="grid-column: 1; grid-row: 2;padding-top: 10px;">
                <form id="plugin-credentials-form" action="options.php" method="post">
                    <div style="padding-top:10px;">
                        <?php 
                        
                        settings_fields( 'dbi_mobile_de_plugin_options' );
                        do_settings_sections( 'dbi_mobile_de_plugin' ); ?>
                    </div>
                    <input name="submit" class="button button-primary" type="submit" value="<?php esc_attr_e( 'Save' ); ?>" />
                    <h2 style="padding-top:120px">Letzte Aktualisierung</h2>
                    <?php 
                    
                        $vehiclesFilePath = $_SERVER["DOCUMENT_ROOT"].'/vehicles.html';     
                        echo $vehiclesFilePath;
                        if (file_exists($vehiclesFilePath))
                        {
                            echo ' <span>'.date_format((new DateTime())->setTimestamp(filemtime($vehiclesFilePath)), "d.m.Y H:i:s").'</span>';
                        } 
                    ?>
                    <h2 style="padding-top:20px">Fehlermeldungen</h2>
                    <?php 
                        $errorFilePath = __DIR__.'/errors.html';        
                        if (file_exists($errorFilePath))
                        {             
                            echo '<div>'.file_get_contents($errorFilePath).'</div>';
                        } 
                    ?>
                </form>
            </div>
            <div style="grid-column: 2; grid-row: 2;padding-left: 30px; padding-right:30px;">
                <iframe class="youtube-video" style="align-self:center;margin:0 auto;padding-top:30px;" src="https://www.youtube-nocookie.com/embed/WcKR6uiC1QE" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>
                <div>
                    <h3>Wo finde ich meine Zugangsdaten?</h3>
                    <p>Wenn du Web Designer bist und im Auftrag deines Autohaus Kunden agierst, musst du diesen bitten, sich in den mobile.de Händler Account einzuloggen und die Inseratseinbindung zu aktivieren.</p>
                    <p>Navigiere im Händleraccount bei mobile.de zu "Bestand" ➡️&nbsp;&nbsp;"Händler Werbung und Services" ➡️&nbsp;&nbsp;"Inserats-Einbundung". Aktiviere hier die Inseratseinbindung.</p>
                    <p>Die Nutzungsbedingungen müssen akzeptiert werden und ein neues Passwort erstellt werden. Der hier generierte API Nutzername und das API Password werden benötigt, damit das Plugin funktiniert. Diese 3 Daten müssen in die nebensteheneden Felder hier im Plugin-Beriech eingegeben werden. Das Feld Telefonnummer ist optional.</p>
                    <p>Hast du Probleme oder Fragen zum Plugin? Schreibe uns gerne an <a href=mailto:kontakt@wordpress-mobile.de>kontakt@wordpress-mobile.de</a></p>
                    
                    <p>Vielen Dank, dass du unser Plugin testest!
                        Wir freuen uns über jeden neuen Nutzer. <br/>😊&nbsp;&nbsp;🧑🏼‍💻&nbsp;&nbsp;👩🏻‍💻
                    </p>
                </div>
            </div>
        </div>
<?php
}

add_action( 'admin_menu', 'mobile_de_plugin_register_settings' );

function dbi_register_settings() {
    register_setting('dbi_mobile_de_plugin_options', 'dbi_mobile_de_plugin_options');
    add_settings_section( 'api_settings', '', '', 'dbi_mobile_de_plugin' );

    add_settings_field( 'dbi_plugin_setting_customer_id', 'mobile.de Händler-ID', 'dbi_plugin_setting_customer_id', 'dbi_mobile_de_plugin', 'api_settings' );
    add_settings_field( 'dbi_plugin_setting_username', 'mobile.de Benutzernamen (API)', 'dbi_plugin_setting_username', 'dbi_mobile_de_plugin', 'api_settings' );
    add_settings_field( 'dbi_plugin_setting_password', 'mobile.de Password (API)', 'dbi_plugin_setting_password', 'dbi_mobile_de_plugin', 'api_settings' );
    add_settings_field( 'dbi_plugin_setting_phone_number', 'Autohaus Telefonnummer (optional)', 'dbi_plugin_setting_phone_number', 'dbi_mobile_de_plugin', 'api_settings' );
    add_settings_field( 'dbi_plugin_setting_refresh_token', ' ', 'dbi_plugin_setting_refresh_token', 'dbi_mobile_de_plugin', 'api_settings' );
}

function dbi_plugin_setting_customer_id() {
    $options = get_option('dbi_mobile_de_plugin_options');    
    $val = "";
    if (!empty($options['customer_id'])) { 
        $val = esc_attr( $options['customer_id'] );
    }
    echo "<input id='dbi_plugin_setting_customer_id' name='dbi_mobile_de_plugin_options[customer_id]' type='text' value='".$val."' />";
}

function dbi_plugin_setting_username() {
    $options = get_option( 'dbi_mobile_de_plugin_options' );
    $val = "";
    if (!empty($options['username'])) { 
        $val = esc_attr( $options['username'] );
    }
    echo "<input id='dbi_plugin_setting_username' name='dbi_mobile_de_plugin_options[username]' type='text' value='".$val."' />";
}

function dbi_plugin_setting_password() {
    $options = get_option( 'dbi_mobile_de_plugin_options' );
    $val = "";
    if (!empty($options['password'])) { 
        $val = esc_attr( $options['password'] );
    }
    echo "<input id='dbi_plugin_setting_password' name='dbi_mobile_de_plugin_options[password]' type='password' value='".$val."' />";
    
}

function dbi_plugin_setting_phone_number() {
    $options = get_option( 'dbi_mobile_de_plugin_options' );
    $val = "";
    if (!empty($options['phone_number'])) { 
        $val = esc_attr( $options['phone_number'] );
    }
    echo "<input id='dbi_plugin_setting_phone_number' name='dbi_mobile_de_plugin_options[phone_number]' type='text' value='".$val."' />";
    
}


function dbi_plugin_setting_refresh_token() {
    $options = get_option( 'dbi_mobile_de_plugin_options' );
    $val = "";
    if (!empty($options['refresh_token'])) { 
        $val = esc_attr( $options['refresh_token'] );
    }
    
    echo "<input id='dbi_plugin_setting_refresh_token' name='dbi_mobile_de_plugin_options[refresh_token]' type='hidden' value='".$val."' />";
}

function getAccessToken(){
    $options = get_option('dbi_mobile_de_plugin_options');
    $refreshToken = $options['refresh_token'];
    
    if (empty($refreshToken)) { 
        throw new Exception('Refresh token is empty, go to mobile.de settings and logout + login again ');
    }
    $curl = curl_init();
        
    curl_setopt_array($curl, array(
        CURLOPT_URL => "https://securetoken.googleapis.com/v1/token?key=".$_ENV["apiKey"],
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => "grant_type=refresh_token&refresh_token=".$refreshToken,
        CURLOPT_HTTPHEADER => array(
        "Content-Type: application/x-www-form-urlencoded"
        ),
    ));

    $response = curl_exec($curl);

    curl_close($curl);
    
    $retVal = json_decode($response);

    return $retVal->{'access_token'};
}

function getData(){
    $options = get_option('dbi_mobile_de_plugin_options');

    $username = $options['username'];
    $pass = $options['password'];
    $customerId  = $options['customer_id'];
    $phoneNumber  = $options['phone_number'];
    $mobileDeAuth = base64_encode($username.':'.$pass);
    $domain = get_option('siteurl');

    $accessToken = get_option('access_token');
    if (empty($accessToken)){        
        $accessToken = getAccessToken();
        add_option('access_token', $accessToken);
    }

    if (empty($accessToken)){  
        throw new Exception('access token is empty, go to mobile.de settings and logout + login again');
    }

    $curl = curl_init();
    $configs = include('config.php');
    $url = $configs['function-base-url'];
    
    $url.= "/helloWorld?customerId=".urlencode($customerId).'&phoneNumber='.urlencode($phoneNumber);
    //echo '<span>access-token: '.$accessToken.', mobile-de-auth: '.$mobileDeAuth.', domain: '.$domain.'</span>';
    curl_setopt_array($curl, array(
      CURLOPT_URL => $url,
      CURLOPT_RETURNTRANSFER => true,
      CURLOPT_ENCODING => "",
      CURLOPT_MAXREDIRS => 10,
      CURLOPT_TIMEOUT => 0,
      CURLOPT_FOLLOWLOCATION => true,
      CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
      CURLOPT_CUSTOMREQUEST => "GET",
      CURLOPT_HTTPHEADER => array(        
        "Authorization: Bearer ".$accessToken,
        "MobileDeAuth: ".$mobileDeAuth,
        "Domain: ".$domain
      ),
    ));
    
    $result = curl_exec($curl);    
    
    $http_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
    curl_close($curl);
    
    $obj = new stdClass;
    $obj->status = $http_code;
    $obj->content = $result;
    return $obj;
}

function mobile_de_wordpress_plugin ( $atts ) {    
    $file = $_SERVER["DOCUMENT_ROOT"]."/vehicles.html";
    
    $isFileExisting = file_exists($file);
    if($isFileExisting){
        $fileLastChangeDate = new DateTime();
        $fileLastChangeDate->setTimestamp(filemtime($file));
        
        $now = new DateTime();
        $now->setTimestamp(time());

        $secondsElapsed = $now->getTimestamp() - $fileLastChangeDate->getTimestamp();        
        $minutes = 60;
                
        $secondsTriggeringRefresh = 0;
        $configs = include('config.php');
        $url = $configs['function-base-url'];
        $isProd = strpos($url, 'cloudfunctions.net') !== false;

        if ($isProd) {            
            $secondsTriggeringRefresh = 60*$minutes;    
        }  else {
            echo 'seconds elapsed: '.$secondsElapsed.' | secondsTriggeringRefresh: '.$secondsTriggeringRefresh;
        }
        
        if ($secondsElapsed >= $secondsTriggeringRefresh) {            
            get_vehicle_data();
        } 
        return file_get_contents($file);
    }

    
    get_vehicle_data();
    
    $isFileExisting = file_exists($file);
    $content = "no data, check plugin settings";
    if ($isFileExisting){
        $content = file_get_contents($file);
    }
    
    return $content;
}

function log_error ($message) {
    $errorFilePath = __DIR__.'/errors.html';
    $log_line = date_format(new DateTime(), "d.m.Y H:i:s")." ".$message."</br>";
    $isFileExisting = file_exists($errorFilePath);
    
    if($isFileExisting){                    
        $logTruncateSizeInKB = 10;
        $logSizeLimit = $logTruncateSizeInKB * 1024;
        $logContent = file_get_contents($errorFilePath);
        if (strlen($logContent) > $logSizeLimit){
            $logContent = substr($logContent, 0, $logSizeLimit);
        }
        
        $log_line.= $logContent;
    }
    file_put_contents($errorFilePath, $log_line);
}

function get_vehicle_data ($forceRefresh=false) {
    $file = $_SERVER["DOCUMENT_ROOT"]."/vehicles.html";
    try{
        $result = getData();
        
        switch ($result->status) {         
            case 401:            
                $accessToken = getAccessToken();                
                update_option('access_token', $accessToken);
                if ($forceRefresh == false){
                    get_vehicle_data(true);
                }
            break;            
            case 200:
                file_put_contents($file, $result->content);
            break;
            default:
                $errorMessage = $result->content;
                if ($result->status == 0){
                    $errorMessage = "Can't connect to firebase";
                }
                log_error($errorMessage);
        }
    } catch( Exception $e){
        log_error($e->getMessage());
    }
}

add_action( 'admin_init', 'dbi_register_settings' );
add_shortcode('mobile_de_plugin', 'mobile_de_wordpress_plugin');
